#ifndef _MRX_ALSA_H_
#define _MRX_ALSA_H_

#define ALSA_PCM_NEW_HW_PARAMS_API
#include <alsa/asoundlib.h>

#define BYTES_PER_SAMPLE 2
#define CHANNELS 1
#define BYTES_PER_FRAME (BYTES_PER_SAMPLE*CHANNELS)
#define DRATE 22100
#define NUM_OF_FRAMES 96  /* 256 works also */
#define DEFAULT_DETECT_LEVEL 1000 /* for 96 FRAMES */
#define DEFAULT_FREQUENCY 850.0

#ifdef MAIN
# define EXTERN 
#else
# define EXTERN extern
#endif
EXTERN double DetectLevel
#ifdef MAIN
=DEFAULT_DETECT_LEVEL
#endif
;
EXTERN double Frequency
#ifdef MAIN
=DEFAULT_FREQUENCY
#endif
;
EXTERN snd_pcm_t *capture_handle;
#undef EXTERN

int init_alsa(void);
int getstat_alsa(void);
double detect_goertzel(double dval[], int num_of_frames, double freq);
void exit_alsa(void);

#endif
