#define extern static
#  include <asm/io.h>
#undef extern
#include <sys/types.h>
#include "mrx.h"
#include "mrx_lpt.h"

/********************************************************************

NAME
	init_lpt()

SYNOPSIS
	int init_lpt(void)

DESCRIPTION
        gets permission to use port LPT1 (or other, no. in InPort)

ARGUMENTS
        ---
        
RETURN VALUE
        ---
        
NOTE
        * needs SUID-Bit to run (please don't run as root!)
        * uses global variable InPort
        
SEE ALSO
        ioperm(): see IO-Hardware-Programming-HOWTO
        getuid()
        
Date       Changes
------------------
xx.xx.xxxx New

*********************************************************************/

int init_lpt(void)
{
   ioperm(InPort,1,1);
   setuid(getuid());
   return 0;

}/* init_lpt() */

/********************************************************************

NAME
	getstat_lpt()

SYNOPSIS
        #define extern static
        #  include <asm/io.h>
        #undef extern
        int InPort;
        int InBit;
        int InInvert;
        
	int getstat_lpt(void);

DESCRIPTION
	Returns Status of Bit Nr. InBit of Port Nr. InPort.
	If InInvert is True, Status is been inverted.

ARGUMENTS
	---

RETURN VALUE + ERRORS
        0,1: Return Status.

SEE ALSO
        inb(), ioperm(2)
        
Date       Changes
------------------
24.02.2007 New

*********************************************************************/

int getstat_lpt(void)
{
      unsigned char ch;
      int rc;
      ch =   inb(INPORT);
      ch &=  (1<<INBIT) ;
      ch >>= INBIT      ;
      if(ININVERT) rc = !ch;
      else         rc = ch ;
      return rc;
   
}/* getstat_lpt() */

/********************************************************************

NAME
	exit_lpt()

SYNOPSIS
        void exit_lpt(void);

DESCRIPTION
        Dummy function; closes lpt.

ARGUMENTS
	---

RETURN VALUE + ERRORS
        ---

SEE ALSO
        exit_alsa()
        
Date       Changes
------------------
22.10.2008 New

*********************************************************************/

void exit_lpt(void){}
