#include <errno.h>
#include <stdio.h>
#define extern static
#  include <asm/io.h>
#undef extern
#include <string.h>
#include <sys/types.h>
#include <unistd.h>

/*****************************************************/

#include "mtrx.h"
#include "mtx.h"

char getascii(void);
int putcw(char ch, char *m2a);
   void fputdit(char dit);
      void putdit(int dit);
         void putstat(int level, int duration);

/*****************************************************/

int main(void)
{
   char m2a[MMAX];
   
   ioperm(OUTPORT,1,1);
   setuid(getuid());
   
   m2ainit(m2a, MMAX);
   while(1)
   {
      char ch;
      ch=getascii();
      putcw(ch,m2a);
   }
   return 0;
   
}/* main() */
                                    
/*****************************************************/

char getascii(void)
{
   char ch;
   int rc=0;
   while(rc<1)
   {
      rc = read(fileno(stdin),&ch,1);
      if(rc==-1)
      {
         fprintf(stderr,"Error: read()= %s!\n", strerror(errno));
         return 0;
      }
   }
#if debug11
   fprintf(stderr,"%c",ch); 
#endif
   return ch;
   
}/* getascii() */

/***********************************************/

int putcw(char ch, char *m2a)
{
   int codenr;
   char *rp;

   if (ch==SPCSYMBOL)
   {
      fputdit(PAUSEBETWEENWORDS);
      return 0;
   }

   rp = strchr(m2a,ch);
   if(!rp)
   {  
      return 1; 
   }
   
   codenr=rp-m2a;
#if debug12
   fprintf(stderr,">%d<",codenr);
#endif

   do
   {
      if(codenr%2) fputdit(DIT);
      else         fputdit(DAH);
      codenr /= 2;
      fputdit(PAUSEWITHINCHAR);
   }
   while(codenr>1);
   fputdit(PAUSEBETWEENCHAR);

}/* putcw() */

/***********************************************/
/* zwischenspeicherung des jeweils letzten Zeichens */
/***********************************************/

void fputdit(char dit)
{
   static int LastDit=-1;
   if(LastDit>=0)
   {
      if(!(LastDit==PAUSEWITHINCHAR  && dit==PAUSEBETWEENCHAR)
      && !(LastDit==PAUSEWITHINCHAR  && dit==PAUSEBETWEENWORDS)
      && !(LastDit==PAUSEBETWEENCHAR && dit==PAUSEBETWEENWORDS))      
      {
         putdit(LastDit);
#if debug13
         {
            char ditout2[][5]=DITOUT2;
            fprintf(stderr,"%s",ditout2[LastDit]);
         }
#endif
      }
   }
   LastDit=dit;
   return;

}/* fputdit() */

/************************************************/

void putdit(int dit)
{
   switch(dit)
   {
      case DIT: putstat(1,1); break;
      case DAH: putstat(1,3); break;
      case PAUSEWITHINCHAR: putstat(0,1); break;
      case PAUSEBETWEENCHAR: putstat(0,3); break;
      case PAUSEBETWEENWORDS: putstat(0,7); break;
      default: break;
   }
   return;
   
}/* putdit() */

/*************************************************/

void putstat(int level, int duration)
{
   unsigned char outp;
   outp=0;   
   if((level && !OUTINVERT) 
   || (!level && OUTINVERT)) outp = 1<<OUTBIT;
   outb(outp,OUTPORT);
   usleep(1000*STDDUR*duration);
   
}/* putstat() */
