#ifndef _MTX_ALSA_H_
#define _MTX_ALSA_H_

#ifndef ALSA_PCM_NEW_HW_PARAMS_API
# define ALSA_PCM_NEW_HW_PARAMS_API
#endif
#include <alsa/asoundlib.h>

#define T_BYTES_PER_SAMPLE 2
#define T_CHANNELS 1
#define T_BYTES_PER_FRAME (BYTES_PER_SAMPLE*CHANNELS)
#define T_DRATE 22050
#define T_FREQUENCY 850.0
#define T_LEVEL 10.0
#define T_NUM_OF_FRAMES T_DRATE /* so putstat_talsa() will combine */
                                /* parts of one second length; if  */
                                /* frequency has no fractional     */
                                /* portion, after one second the   */
                                /* sine wave has a zero value and  */
                                /* the fractionaries are matching. */
#ifdef MAIN
# define EXTERN 
#else
# define EXTERN extern
#endif
EXTERN snd_pcm_t *playback_handle;
#undef EXTERN

int init_talsa(void);
void putstat_talsa(int level, int duration);
void exit_talsa(void);

#endif
