#include <stdio.h>
#define MAIN
#include "mrx_alsa.h"
#undef MAIN

void main_voltage(void);
void disp_voltage(void);
void main_frequency(void);

/****************************************************/
int main(void)
{ 
   int rc;
   while(rc)
   {
      printf("%s", "This program prints the status of the mic input.\n"
                   "<0> Quit\n"
                   "<1> Print input voltage (in percent)\n"
                   "<2> Print input power at 10 different frequencies\n"
                   "Input: ");
      scanf("%i", &rc);
      
      switch(rc)
      {
      case 0: break;;
      case 1: main_voltage();   break;
      case 2: main_frequency(); break;
      default: fprintf(stderr, "unused mode!\n");
      break;
      }
   
   }/* while */ 
   return 0;
   
}/* main() */

/*****************************************************/

void main_frequency(void)
{   
   int16_t buf[NUM_OF_FRAMES];
   int i;
   double x[NUM_OF_FRAMES];
   int runs=30;
   
   init_alsa();
   for(i=0; i<10; ++i) { printf("|%6.0lf Hz", 300.0+100.0*i); } printf("|\n");
   while(--runs)
   {
      double y[10];
      int rc;
      while ((rc = snd_pcm_readi (capture_handle, (void *)buf, NUM_OF_FRAMES)) != NUM_OF_FRAMES)
      {
         if(rc==-EPIPE) snd_pcm_prepare(capture_handle);
         else
         {
            fprintf (stderr, "read from audio interface failed (%d/%s)\n", rc, snd_strerror (rc));
            exit(1);
         }
      }/* if */

      for(i=0; i<NUM_OF_FRAMES; ++i)
      {
         x[i]=buf[i]*100.0/32768.0;
      }
      for(i=0; i<10; ++i)
      {
         y[i]=detect_goertzel(x,NUM_OF_FRAMES, 300.0+100.0*i);
         printf("|%9.3lf",y[i]);
      }
      printf("|\n");
      usleep(50000);
   }/* while */
   printf("\n");   
   exit_alsa();
   
}/* main_frequency() */

/*************************************************************/

void main_voltage(void)
{   
   int16_t buf[NUM_OF_FRAMES];
   int runs=10;
   init_alsa();
   while(--runs)
   {
      disp_voltage();
      usleep(50000);
   }/* while */
   printf("\n");
   exit_alsa();
}/* main_voltage() */

/*****************************************************/

void disp_voltage(void)
{
   int16_t buf[NUM_OF_FRAMES];
   int i;
   int rc;
   while((rc = snd_pcm_readi (capture_handle, (void *)buf, NUM_OF_FRAMES)) != NUM_OF_FRAMES)
   {
      if(rc==-EPIPE) snd_pcm_prepare(capture_handle);
      else
      {
         fprintf(stderr, "read from audio interface failed (%d/%s)\n", rc, snd_strerror (rc));
         exit(1);
      }/* else */
   }/* while */
          
   for(i=0; i<NUM_OF_FRAMES; ++i)
   {
      double disp;
      disp=buf[i]*100.0/32768;
      printf("|%+7.3lf", disp);
      if(i%10==9) printf("\n");
   }/* for */
   printf("*\n");
   
}/* disp_voltage */
